var SpeedDialMultiKey = {
  initialNumber: 0,
  numberThumbnails: 0,
  numberDigits: 0,
  ctrlPressed: false,
  shiftPressed: false,
  altPressed: false,
  digitBox: null,
  cancelledMultikey: false,
  isClosing: false,
  multikeyBundle: null,
  targetAction: 0,
  multikeySelectWhenComplete: false,
  showingMultiKey: false,
  initiatedFirefox3: false,

  Startup: function() {
    /*
    SpeedDialMultiKey.initialNumber = window.arguments[0];
    SpeedDialMultiKey.numberThumbnails = window.arguments[1];
    SpeedDialMultiKey.callbackFunction = window.arguments[2];
    SpeedDialMultiKey.cancelCallbackFunction = window.arguments[3];
    SpeedDialMultiKey.ctrlPressed = window.arguments[4];
    SpeedDialMultiKey.shiftPressed = window.arguments[5];
    SpeedDialMultiKey.altPressed = window.arguments[6];
    var desiredWidth = window.arguments[7];
    SpeedDialMultiKey.targetAction = window.arguments[8];
    */
    SpeedDialMultiKey.isClosing = false;
    
    if (SpeedDialMultiKey.multikeyBundle == null) {
      SpeedDialMultiKey.multikeyBundle = document.getElementById("speeddial_bundle_multikey");
    }
    
    SpeedDialMultiKey.multikeySelectWhenComplete = SpeedDial.prefs.getBoolPref("multikeySelectWhenComplete");
    
    // Set size
    var mainBox = document.getElementById("speeddial-multikeyMainBox");
    
    // Set action label
    var actionLabel = document.getElementById("speeddial-multikeyAccessDialLabel");
    if (SpeedDialMultiKey.targetAction == 1) {
      actionLabel.setAttribute("value", SpeedDialMultiKey.multikeyBundle.getString("currentTab.label"));
    } else if (SpeedDialMultiKey.targetAction == 2) {
      actionLabel.setAttribute("value", SpeedDialMultiKey.multikeyBundle.getString("newTab.label"));
    } else if (SpeedDialMultiKey.targetAction == 3) {
      actionLabel.setAttribute("value", SpeedDialMultiKey.multikeyBundle.getString("backgroundTab.label"));
    } else if (SpeedDialMultiKey.targetAction == 4) {
      actionLabel.setAttribute("value", SpeedDialMultiKey.multikeyBundle.getString("newWindow.label"));
    } else if (SpeedDialMultiKey.targetAction == 5) {
      actionLabel.setAttribute("value", SpeedDialMultiKey.multikeyBundle.getString("saveDisk.label"));
    }
    
    // Add digits
    SpeedDialMultiKey.digitBox = document.getElementById("speeddial-multikeyDigitBox");
    
    SpeedDialMultiKey.numberDigits = 0;
    var currentNumber = SpeedDialMultiKey.numberThumbnails;
    while (currentNumber > 0) {
      SpeedDialMultiKey.numberDigits++;
      currentNumber /= 10;
      currentNumber = Math.floor(currentNumber);
    }
    
    while (SpeedDialMultiKey.digitBox.firstChild) {
      SpeedDialMultiKey.digitBox.removeChild(SpeedDialMultiKey.digitBox.firstChild);
    }

    for (var c=SpeedDialMultiKey.numberDigits; c>0; c--) {
      var newImage = document.createElement("image");
      newImage.setAttribute("id", "speeddial-multikeyDigit" + c);
      newImage.setAttribute("class", "multikeyDigit");
      if (c != 1) {
        newImage.setAttribute("number", "?");
      } else {
        newImage.setAttribute("number", SpeedDialMultiKey.initialNumber);
      }
      SpeedDialMultiKey.digitBox.appendChild(newImage);
    }
    
    SpeedDialMultiKey.updateCurrentDialData();
    /*
    addEventListener("keydown", function(event) { keyDownHandler(event); }, true);
    addEventListener("keyup", function(event) { keyUpHandler(event); }, true);
    addEventListener("blur", function(event) { blurHandler(event); }, false);
    */
  },

  Unload: function() {
    if (!SpeedDialMultiKey.cancelledMultikey) {
      SpeedDial.multikeyDialSelected(SpeedDialMultiKey.getCurrentNumber(), SpeedDialMultiKey.targetAction);
    }
  },
  
  show: function() {
    var mainBox = document.getElementById("speeddial-multikeyMainBox");
    var mainSubBox = document.getElementById("speeddial-multikeyMainSubBox");
    var multikeyBackground = document.getElementById("speeddial-multikey-background");

    if (SpeedDial.isFirefox3) {
      // "panel" only exists on Firefox 3
      var targetPanel;
      if (!SpeedDialMultiKey.initiatedFirefox3) {
        mainBox.removeChild(mainSubBox);
        
        var targetPanel = document.createElement("panel");
        targetPanel.setAttribute("id", "speeddial-multikey-panel");
        
        targetPanel.appendChild(mainSubBox);
          
        document.getElementById("mainPopupSet").appendChild(targetPanel);
        SpeedDialMultiKey.initiatedFirefox3 = true;
      } else {
        targetPanel = document.getElementById("speeddial-multikey-panel");
      }
      var multiKeyWidth = Math.floor(window.innerWidth * SpeedDial.prefs.getIntPref("multikeyOverlayWidthModifier") / 100);
      var multiKeyHeight = targetPanel.boxObject.height;
      targetPanel.setAttribute("width", multiKeyWidth);
      targetPanel.setAttribute("left", Math.floor((screen.availWidth - multiKeyWidth) / 2));
      targetPanel.setAttribute("top", (screen.availHeight - multiKeyHeight) / 2);
      targetPanel.openPopup(null, "", 0, 0, false, true);
    } else {
      mainBox.setAttribute("multikey-shown", true);
      mainSubBox.style.width = mainBox.style.width  = window.innerWidth+'px';
      mainSubBox.style.height = mainBox.style.height  = window.innerHeight+'px';
   
      multikeyBackground.style.width  = (window.innerWidth * 2)+'px';
      multikeyBackground.style.height = (window.innerHeight * 2)+'px';
      multikeyBackground.setAttribute("multikey-shown", true);
    }
    
    SpeedDialMultiKey.showingMultiKey = true;
    
    SpeedDialMultiKey.Startup();
  },
  
  hide: function() {
    if (SpeedDial.isFirefox3) {
      document.getElementById("speeddial-multikey-panel").hidePopup();
    } else {
      document.getElementById("speeddial-multikeyMainBox").setAttribute("multikey-shown", false);
      document.getElementById("speeddial-multikey-background").setAttribute("multikey-shown", false);
    }

    SpeedDialMultiKey.showingMultiKey = false;
 
    SpeedDialMultiKey.Unload();
  },

  updateCurrentDialData: function() {
    var currentNumber = SpeedDialMultiKey.getCurrentNumber();
    
    if ((currentNumber < 1) || (currentNumber > SpeedDialMultiKey.numberThumbnails)) {
      document.getElementById("speeddial-multikeyCurrentDialLabel").setAttribute("value", SpeedDial.bundle.getString("outofrange.label"));
      document.getElementById("speeddial-multikeyCurrentDialIcon").removeAttribute("src");
      document.getElementById("speeddial-multikeyCurrentDialURL").setAttribute("value", " ");
    } else if (SpeedDial.prefs.prefHasUserValue("thumbnail-" + currentNumber + "-url")) {
      var title = SpeedDial.prefs.getComplexValue("thumbnail-" + currentNumber + "-label", Components.interfaces.nsISupportsString).data;
      if (title == "") {
        document.getElementById("speeddial-multikeyCurrentDialLabel").setAttribute("value", SpeedDial.bundle.getString("untitled.label"));
      } else {
        document.getElementById("speeddial-multikeyCurrentDialLabel").setAttribute("value", title);
      }
      var thumbnailIcon = "";
      if (SpeedDial.isFirefox3) {
        thumbnailIcon = SpeedDialUtils.getDialIcon(currentNumber, thumbnailIcon, "src");
      } else {
        if (SpeedDial.prefs.prefHasUserValue("thumbnail-" + currentNumber + "-icon")) {
          thumbnailIcon =  SpeedDial.prefs.getCharPref("thumbnail-" + currentNumber + "-icon");
          if (thumbnailIcon == "data:") {
            thumbnailIcon = "";
          }
        }
      }
      if (thumbnailIcon != null) {
        document.getElementById("speeddial-multikeyCurrentDialIcon").setAttribute("src", thumbnailIcon);
      }
      
      document.getElementById("speeddial-multikeyCurrentDialURL").setAttribute("value", SpeedDial.prefs.getCharPref("thumbnail-" + currentNumber + "-url"));
    } else {
      document.getElementById("speeddial-multikeyCurrentDialLabel").setAttribute("value", SpeedDial.bundle.getString("unassigned.label"));
      document.getElementById("speeddial-multikeyCurrentDialIcon").removeAttribute("src");
      document.getElementById("speeddial-multikeyCurrentDialURL").setAttribute("value", " ");
    }
  },

  keyDownHandler: function(event) {
    var processed = false;
    
    if (event.keyCode == 16) {
      SpeedDialMultiKey.shiftPressed = true;
      processed = true;
    } else if (event.keyCode == 17) {
      SpeedDialMultiKey.ctrlPressed = true;
      processed = true;
    } else if ((event.keyCode == 18) || (event.keyCode == 224)) {  // Alt or Apple key
      SpeedDialMultiKey.altPressed = true;
      processed = true;
    } else if (event.keyCode == 13) { // Enter
      SpeedDialMultiKey.isClosing = true;
      SpeedDialMultiKey.hide();
      processed = true;
    } else if (event.keyCode == 8) { // Backspace
      SpeedDialMultiKey.processBackspace();
      processed = true;
    } else if (event.keyCode == 27) { // Escape
      SpeedDialMultiKey.cancelDialog();
      processed = true;
    } else if ((event.keyCode == 37) || (event.keyCode == 38) || (event.keyCode == 109)) { // Cursor up, left, and minus
      SpeedDialMultiKey.goPreviousDial();
      processed = true;
    } else if ((event.keyCode == 39) || (event.keyCode == 40) || (event.keyCode == 61)) { // Cursor down, right, and plus
      SpeedDialMultiKey.goNextDial();
      processed = true;
    }

    if (processed == true) {
      event.preventDefault();
      event.preventBubble();
      event.preventCapture();
      event.stopPropagation();
    }
  },

  keyUpHandler: function (event) {
    var processed = false;
    if (event.keyCode == 16) {
      processed = true;
      SpeedDialMultiKey.shiftPressed = false;
    } else if (event.keyCode == 17) {
      processed = true;
      SpeedDialMultiKey.ctrlPressed = false;
    } else if ((event.keyCode == 18) || (event.keyCode == 224)) {
      processed = true;
      SpeedDialMultiKey.altPressed = false;
    } else if ((event.keyCode == 13) || (event.keyCode == 8) || (event.keyCode == 27) ||(event.keyCode == 37) || (event.keyCode == 38) || (event.keyCode == 109) || (event.keyCode == 39) || (event.keyCode == 40) || (event.keyCode == 61)) {
      processed = true;
    }
    if (!SpeedDialMultiKey.ctrlPressed && !SpeedDialMultiKey.shiftPressed && !SpeedDialMultiKey.altPressed) {
      SpeedDialMultiKey.isClosing = true;
      SpeedDialMultiKey.hide();
    } else if (processed) {
      event.preventDefault();
      event.preventBubble();
      event.preventCapture();
      event.stopPropagation();
    }
  },

  processKey: function (event, typedNumber) {
    var firstDigit = document.getElementById("speeddial-multikeyDigit" + SpeedDialMultiKey.numberDigits);
    
    for (var c=SpeedDialMultiKey.numberDigits; c>1; c--) {
      document.getElementById("speeddial-multikeyDigit" + c).setAttribute("number", document.getElementById("speeddial-multikeyDigit" + (c - 1)).getAttribute("number"));
    }
    
    // Set last digit
    document.getElementById("speeddial-multikeyDigit1").setAttribute("number", typedNumber);
    
    SpeedDialMultiKey.updateCurrentDialData();
    
    if ((firstDigit.getAttribute("number") != "?") && (SpeedDialMultiKey.multikeySelectWhenComplete)) {
      // Completed! Process
      SpeedDialMultiKey.isClosing = true;
      SpeedDialMultiKey.hide();
    }
    
    event.preventDefault();
    event.preventBubble();
    event.preventCapture();
    event.stopPropagation();
  },

  processBackspace: function () {
    for (var c=1; c<=SpeedDialMultiKey.numberDigits; c++) {
      if (c<SpeedDialMultiKey.numberDigits) {
        document.getElementById("speeddial-multikeyDigit" + c).setAttribute("number", document.getElementById("speeddial-multikeyDigit" + (c + 1)).getAttribute("number"));
      } else {
        document.getElementById("speeddial-multikeyDigit" + c).setAttribute("number", "?");
      }
    }
    SpeedDialMultiKey.updateCurrentDialData();
  },

  goPreviousDial: function () {
    var currentNumber = SpeedDialMultiKey.getCurrentNumber();
    var originalNumber = currentNumber;
    do {
      currentNumber--;
      if (currentNumber < 1) {
        currentNumber = SpeedDialMultiKey.numberThumbnails;
      }
    } while ((currentNumber != originalNumber) && !SpeedDial.prefs.prefHasUserValue("thumbnail-" + currentNumber + "-url"));
  
    if (currentNumber != originalNumber) {
      SpeedDialMultiKey.setCurrentNumber(currentNumber);
    }
  },

  goNextDial: function () {
    var currentNumber = SpeedDialMultiKey.getCurrentNumber();
    var originalNumber = currentNumber;
    do {
      currentNumber++;
      if (currentNumber > SpeedDialMultiKey.numberThumbnails) {
        currentNumber = 1;
      }
    } while ((currentNumber != originalNumber) && !SpeedDial.prefs.prefHasUserValue("thumbnail-" + currentNumber + "-url"));
    
    if (currentNumber != originalNumber) {
      SpeedDialMultiKey.setCurrentNumber(currentNumber);
    }
  },

  setCurrentNumber: function (currentNumber) {
    for (var c=1; c<=SpeedDialMultiKey.numberDigits; c++) {
      var currentDigit = document.getElementById("speeddial-multikeyDigit" + c);
      if (currentNumber > 0) {
        currentDigit.setAttribute("number", parseInt(currentNumber % 10));
        currentNumber = Math.floor(currentNumber / 10);
      } else {
        currentDigit.setAttribute("number", "?");
      }
    }
    SpeedDialMultiKey.updateCurrentDialData();
  },

  getCurrentNumber: function () {
    var currentModifier = 1;
    var currentValue = 0;
    
    for (var c=1; c<=SpeedDialMultiKey.numberDigits; c++) {
      var digitValue = document.getElementById("speeddial-multikeyDigit" + c).getAttribute("number");
      if (digitValue != "?") {
        currentValue += parseInt(digitValue) * currentModifier;
      }
      currentModifier *= 10;
    }
    
    return currentValue;
  },

  cancelDialog: function () {
    if (!SpeedDialMultiKey.isClosing) {
      SpeedDialMultiKey.cancelledMultikey = true;
      SpeedDialMultiKey.isClosing = true;
      SpeedDialMultiKey.hide();
    }
  },

  blurHandler: function (event) {
    SpeedDialMultiKey.cancelDialog();
  }
}